/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Skeleton implementation for Bison GLR parsers in C

   Copyright (C) 2002-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C GLR parser skeleton written by Paul Hilfinger.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 1






/* First part of user declarations.  */
#line 1 "openinghoursparser.y" /* glr.c:240  */

/*
    SPDX-FileCopyrightText: 2020 Volker Krause <vkrause@kde.org>
    SPDX-License-Identifier: LGPL-2.0-or-later
*/

#include "openinghours_p.h"
#include "openinghoursparser_p.h" // generated
#include "openinghoursscanner_p.h" // generated
#include "logging.h"

using namespace KOpeningHours;

void yyerror(YYLTYPE *loc, OpeningHoursPrivate *parser, yyscan_t scanner, char const* msg)
{
    Q_UNUSED(scanner);
    qCDebug(Log) << "PARSER ERROR:" << msg << "at position" << loc->first_column;
    parser->m_error = OpeningHours::SyntaxError;
}

static void initSelectors(Selectors &sels)
{
    sels.timeSelector = nullptr;
    sels.weekdaySelector = nullptr;
    sels.weekSelector = nullptr;
    sels.monthdaySelector = nullptr;
    sels.yearSelector = nullptr;
    sels.wideRangeSelectorComment.str = nullptr;
    sels.wideRangeSelectorComment.len = 0;
    sels.seen_24_7 = false;
    sels.colonAfterWideRangeSelector = false;
}

static void applySelectors(const Selectors &sels, Rule *rule)
{
    rule->m_timeSelector.reset(sels.timeSelector);
    rule->m_weekdaySelector.reset(sels.weekdaySelector);
    rule->m_weekSelector.reset(sels.weekSelector);
    rule->m_monthdaySelector.reset(sels.monthdaySelector);
    rule->m_yearSelector.reset(sels.yearSelector);
    rule->m_seen_24_7 = sels.seen_24_7;
    rule->m_colonAfterWideRangeSelector = sels.colonAfterWideRangeSelector;
    rule->m_wideRangeSelectorComment = QString::fromUtf8(sels.wideRangeSelectorComment.str, sels.wideRangeSelectorComment.len);
}

static bool extendMonthdaySelector(MonthdayRange *monthdaySelector, int beginDay, int endDay)
{
    const auto prevSelector = lastSelector(monthdaySelector);
    if (prevSelector->begin.year == prevSelector->end.year
     && prevSelector->begin.month == prevSelector->end.month)
    {
        auto sel = new MonthdayRange;
        sel->begin = sel->end = prevSelector->end;
        sel->begin.day = beginDay;
        sel->end.day = endDay;
        appendSelector(prevSelector, sel);
        return true;
    }
    return false;
}


#line 117 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:240  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "openinghoursparser_p.h"

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template, here we set
   the default value of $$ to a zeroed-out value.  Since the default
   value is undefined, this behavior is technically correct.  */
static YYSTYPE yyval_default;
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;

/* Copy the second part of user declarations.  */

#line 150 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:263  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#define YYSIZEMAX ((size_t) -1)

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

#ifndef YYSETJMP
# include <setjmp.h>
# define YYJMP_BUF jmp_buf
# define YYSETJMP(Env) setjmp (Env)
/* Pacify clang.  */
# define YYLONGJMP(Env, Val) (longjmp (Env, Val), YYASSERT (0))
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#ifndef YYASSERT
# define YYASSERT(Condition) ((void) ((Condition) || (abort (), 0)))
#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  70
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   317

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  37
/* YYNRULES -- Number of rules.  */
#define YYNRULES  142
/* YYNRULES -- Number of states.  */
#define YYNSTATES  212
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule.  */
#define YYMAXRHS 6
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule.  */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   290

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35
};

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   233,   233,   234,   235,   239,   243,   252,   264,   268,
     273,   278,   284,   288,   292,   300,   301,   302,   303,   307,
     312,   321,   322,   323,   324,   328,   332,   336,   341,   349,
     350,   351,   352,   356,   364,   368,   372,   377,   385,   390,
     396,   401,   407,   413,   422,   423,   427,   428,   433,   442,
     446,   453,   454,   461,   466,   474,   475,   476,   480,   487,
     488,   495,   500,   505,   510,   519,   520,   524,   528,   533,
     540,   544,   550,   554,   558,   565,   566,   571,   575,   582,
     586,   591,   603,   607,   611,   620,   628,   636,   647,   651,
     654,   658,   662,   667,   672,   677,   682,   686,   692,   699,
     707,   715,   720,   725,   737,   738,   739,   743,   744,   745,
     746,   753,   754,   758,   759,   763,   764,   765,   766,   772,
     776,   782,   786,   793,   797,   801,   810,   815,   825,   832,
     836,   840,   844,   848,   852,   857,   862,   867,   872,   877,
     882,   888,   889
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_NORMAL_RULE_SEPARATOR",
  "T_ADDITIONAL_RULE_SEPARATOR", "T_FALLBACK_SEPARATOR", "T_STATE",
  "T_24_7", "T_YEAR", "T_PLUS", "T_MINUS", "T_SLASH", "T_COLON", "T_COMMA",
  "T_ALT_TIME_SEP", "T_ALT_TIME_SEP_OR_SUFFIX", "T_ALT_TIME_AM",
  "T_ALT_TIME_PM", "T_4DIGIT_TIME", "T_ALT_RANGE_SEP", "T_EVENT",
  "T_LBRACKET", "T_RBRACKET", "T_LPAREN", "T_RPAREN", "T_PH", "T_SH",
  "T_KEYWORD_DAY", "T_KEYWORD_WEEK", "T_EASTER", "T_WHITSUN", "T_WEEKDAY",
  "T_MONTH", "T_INTEGER", "T_COMMENT", "T_INVALID", "$accept", "Ruleset",
  "Rule", "SelectorSequence", "WideRangeSelector", "SmallRangeSelector",
  "TimeSelector", "Timespan", "Time", "VariableTime", "WeekdaySelector",
  "HolidayAndWeekdaySequence", "HolidayAndWeekday",
  "HolidayOrWeekdaySequence", "WeekdaySequence", "WeekdayRange",
  "HolidaySequence", "Holiday", "NthSequence", "NthEntry", "DayOffset",
  "WeekSelector", "Week", "MonthdaySelector", "MonthdayRange",
  "MonthdayRangeAdditional", "DateOffset", "DateFrom", "DateTo",
  "VariableDate", "AltMonthdayOffset", "YearSelector",
  "YearSelectorCombined", "YearRange", "YearRangeStandalone",
  "ExtendedHourMinute", "RangeSeparator", YY_NULLPTR
};
#endif

#define YYPACT_NINF -143
#define YYTABLE_NINF -125

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const short int yypact[] =
{
      74,   -11,  -143,   110,  -143,  -143,  -143,  -143,    20,   238,
    -143,    28,  -143,  -143,   202,   115,   167,    65,   205,  -143,
       9,   139,  -143,   111,  -143,   215,  -143,   151,    71,  -143,
     128,    60,   177,     7,    41,   145,    40,  -143,  -143,   219,
    -143,   103,   148,  -143,   194,  -143,  -143,  -143,  -143,    83,
    -143,   117,  -143,   122,   240,   180,   193,  -143,   222,  -143,
       8,   191,   239,  -143,    77,   227,    62,   121,   228,  -143,
    -143,  -143,    74,    74,    74,   261,   231,  -143,   160,  -143,
     178,    13,  -143,   178,   178,   162,   189,   189,   232,   251,
    -143,   226,   253,  -143,    28,   234,    18,   145,    95,   166,
    -143,    77,    26,    -8,   145,    70,   260,  -143,  -143,    17,
     258,   127,   127,   243,   245,   241,   242,   263,     6,  -143,
    -143,    27,    80,  -143,  -143,  -143,   256,  -143,  -143,  -143,
    -143,  -143,  -143,  -143,  -143,  -143,  -143,   275,  -143,  -143,
     230,   229,  -143,  -143,  -143,  -143,  -143,  -143,   267,    -8,
     268,  -143,  -143,  -143,    85,   201,   212,  -143,  -143,   244,
     145,   208,   266,  -143,   249,  -143,   247,   259,   262,  -143,
    -143,   271,  -143,   252,     8,   238,   254,   269,   212,  -143,
    -143,  -143,  -143,   171,   255,   257,   264,   244,   265,  -143,
     213,  -143,  -143,  -143,  -143,  -143,   270,  -143,  -143,  -143,
     272,   246,  -143,   167,  -143,  -143,  -143,  -143,  -143,   248,
    -143,  -143
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    13,    15,    88,   138,   139,   140,    46,     0,    67,
      69,     0,   113,   114,    61,    90,     0,    12,     0,     2,
       8,    17,    16,    29,    34,    38,    45,    30,    50,    51,
      49,     0,    55,     0,    56,    23,    22,    82,    89,    96,
     109,    21,     0,   121,   119,    44,    14,   128,   141,     0,
     142,    91,   110,     0,     0,     0,     0,    68,    79,    77,
       0,     0,     0,   107,     0,     0,     0,     0,   133,    28,
       1,     7,     0,     0,     0,     0,    10,     9,    18,    19,
       0,     0,    39,     0,    31,    32,     0,     0,     0,    54,
      65,     0,    53,    59,     0,     0,     0,    26,     0,   141,
     106,    97,     0,    88,    25,    24,     0,   126,   108,     0,
     125,     0,     0,     0,     0,     0,     0,    72,     0,    70,
      62,     0,     0,    92,   134,   136,   129,   135,   137,   130,
     132,     3,     4,     5,     6,    11,    20,     0,    36,    35,
      40,    33,    52,    57,    58,    60,    66,    78,    85,     0,
      84,    83,   104,   105,     0,     0,     0,   112,   111,    98,
      27,   123,   120,   124,     0,    93,     0,     0,     0,    75,
      76,    80,    74,     0,     0,    63,     0,     0,     0,   102,
     131,    37,    41,     0,     0,     0,     0,    99,     0,   101,
       0,   100,    94,   127,    47,    48,     0,    73,    71,    64,
       0,   115,    95,    42,    43,    87,    86,   103,    81,   116,
     117,   118
};

  /* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -143,  -143,   163,  -143,  -143,   -13,   -18,   203,    69,  -143,
    -143,  -143,   206,  -143,   273,   -17,   274,   -24,  -143,   119,
      -9,   -30,   195,   276,  -143,   199,  -142,   -90,  -112,    -2,
    -121,  -143,  -143,   190,   196,  -107,   -12
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const short int yydefgoto[] =
{
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,   118,   119,
     100,    35,    59,    36,    37,    38,   101,    39,   159,    40,
      64,    41,    42,    43,    44,    45,    53
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const short int yytable[] =
{
      57,    52,    61,    65,   167,   168,    97,    90,    79,    85,
     179,   104,   158,    83,   138,    76,    93,   191,   116,   174,
      91,    12,    13,    46,    51,   164,   149,   102,   175,     4,
       5,     6,   158,     7,   155,   189,     8,   176,    14,   109,
      54,   117,   187,    77,    95,   207,    16,    12,    13,   165,
      15,   150,   122,    96,   -56,    12,    13,   202,   156,   157,
     177,    58,    90,   144,   158,   136,   141,   146,    11,    93,
     143,   145,   -65,    88,    95,   160,   204,    69,   124,   125,
       1,     2,     3,    96,    86,     9,    10,    48,   155,   154,
       4,     5,     6,   155,     7,   126,    50,     8,    11,     9,
      10,    52,    11,    12,    13,    14,    15,    16,    17,    12,
      13,   103,   178,   157,    12,    13,   107,   186,   157,    47,
      48,    49,    80,   -88,    81,    48,   152,    48,   113,    50,
     110,    11,    12,    13,    50,    15,    50,   127,   128,    12,
      13,    87,    51,     4,     5,     6,    62,    52,    63,   137,
     108,    78,   140,    52,   129,     4,     5,     6,    94,     7,
      16,   106,     8,    84,     9,    10,   199,     4,     5,     6,
      14,     7,    16,    80,     8,    81,     4,     5,     6,    66,
       7,    67,    68,     8,    16,     9,    10,     4,     5,     6,
     -55,    14,   210,    16,     4,     5,     6,   153,     7,   114,
     211,     8,   -59,   -59,   203,    70,    71,  -124,    72,    73,
      74,    16,    48,   113,     9,    10,    75,    47,    48,    49,
      14,    50,   120,    60,    82,    48,   114,    50,    98,    99,
      12,    13,   115,   188,    50,   131,   132,   133,    50,   182,
      80,   183,    81,    62,   153,    63,   114,    55,    56,   111,
     112,     9,    10,    98,   190,    55,    56,    55,    56,   123,
     121,   130,   134,    14,    91,   135,    88,   148,   161,   166,
     169,   180,   170,   173,   171,   172,   181,   184,   185,  -122,
     193,   192,   196,   194,   139,   197,   195,   200,   205,   147,
     206,   201,   142,   198,   209,   151,   162,    63,   108,     0,
       0,     0,   163,   208,     0,    89,    92,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   105
};

static const short int yycheck[] =
{
       9,     3,    14,    15,   111,   112,    36,    31,    21,    27,
     122,    41,   102,    25,     1,     6,    33,   159,    10,    13,
      13,    29,    30,    34,    32,     8,     8,    39,    22,    16,
      17,    18,   122,    20,     8,   156,    23,    10,    31,    51,
      20,    33,   154,    34,     4,   187,    33,    29,    30,    32,
      32,    33,    64,    13,    13,    29,    30,   178,    32,    33,
      33,    33,    86,    87,   154,    78,    84,    91,    28,    86,
      87,    88,    31,    13,     4,   105,   183,    12,    16,    17,
       6,     7,     8,    13,    13,    25,    26,    10,     8,   101,
      16,    17,    18,     8,    20,    33,    19,    23,    28,    25,
      26,   103,    28,    29,    30,    31,    32,    33,    34,    29,
      30,     8,    32,    33,    29,    30,    33,    32,    33,     9,
      10,    11,    11,    13,    13,    10,    31,    10,    33,    19,
       8,    28,    29,    30,    19,    32,    19,    16,    17,    29,
      30,    13,    32,    16,    17,    18,    31,   149,    33,    80,
      33,    12,    83,   155,    33,    16,    17,    18,    13,    20,
      33,    13,    23,    12,    25,    26,   175,    16,    17,    18,
      31,    20,    33,    11,    23,    13,    16,    17,    18,    12,
      20,    14,    15,    23,    33,    25,    26,    16,    17,    18,
      13,    31,   201,    33,    16,    17,    18,    31,    20,    33,
     209,    23,    25,    26,    33,     0,     1,    13,     3,     4,
       5,    33,    10,    33,    25,    26,    11,     9,    10,    11,
      31,    19,    31,    21,     9,    10,    33,    19,     9,    10,
      29,    30,    10,    32,    19,    72,    73,    74,    19,     9,
      11,    11,    13,    31,    31,    33,    33,     9,    10,     9,
      10,    25,    26,     9,    10,     9,    10,     9,    10,    32,
      21,    33,     1,    31,    13,    34,    13,    33,     8,    11,
      27,    15,    27,    10,    33,    33,     1,    10,    10,    13,
      33,    32,    11,    24,    81,    33,    24,    33,    33,    94,
      33,    22,    86,   174,    22,    96,   106,    33,    33,    -1,
      -1,    -1,   106,    33,    -1,    31,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     6,     7,     8,    16,    17,    18,    20,    23,    25,
      26,    28,    29,    30,    31,    32,    33,    34,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    57,    59,    60,    61,    63,
      65,    67,    68,    69,    70,    71,    34,     9,    10,    11,
      19,    32,    65,    72,    20,     9,    10,    56,    33,    58,
      21,    72,    31,    33,    66,    72,    12,    14,    15,    12,
       0,     1,     3,     4,     5,    11,     6,    34,    12,    41,
      11,    13,     9,    72,    12,    42,    13,    13,    13,    52,
      53,    13,    50,    51,    13,     4,    13,    57,     9,    10,
      56,    62,    72,     8,    57,    59,    13,    33,    33,    72,
       8,     9,    10,    33,    33,    10,    10,    33,    54,    55,
      31,    21,    72,    32,    16,    17,    33,    16,    17,    33,
      33,    38,    38,    38,     1,    34,    41,    44,     1,    43,
      44,    42,    48,    51,    53,    51,    53,    58,    33,     8,
      33,    61,    31,    31,    72,     8,    32,    33,    63,    64,
      57,     8,    69,    70,     8,    32,    11,    71,    71,    27,
      27,    33,    33,    10,    13,    22,    10,    33,    32,    64,
      15,     1,     9,    11,    10,    10,    32,    64,    32,    66,
      10,    62,    32,    33,    24,    24,    11,    33,    55,    56,
      33,    22,    66,    33,    71,    33,    33,    62,    33,    22,
      56,    56
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    36,    37,    37,    37,    37,    37,    37,    38,    38,
      38,    38,    38,    38,    38,    39,    39,    39,    39,    39,
      39,    40,    40,    40,    40,    40,    40,    40,    40,    41,
      41,    41,    41,    41,    42,    42,    42,    42,    43,    43,
      43,    43,    43,    43,    44,    44,    45,    45,    45,    46,
      46,    47,    47,    48,    48,    49,    49,    49,    49,    50,
      50,    51,    51,    51,    51,    52,    52,    53,    53,    53,
      54,    54,    55,    55,    55,    56,    56,    57,    57,    58,
      58,    58,    59,    59,    59,    59,    59,    59,    60,    60,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    62,    62,    62,    63,    63,    63,
      63,    64,    64,    65,    65,    66,    66,    66,    66,    67,
      67,    68,    68,    69,    69,    70,    70,    70,    70,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    72,    72
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     3,     3,     3,     3,     2,     1,     2,
       2,     3,     1,     1,     2,     1,     1,     1,     2,     2,
       3,     1,     1,     1,     2,     2,     2,     3,     2,     1,
       1,     2,     2,     3,     1,     3,     3,     4,     1,     2,
       3,     4,     5,     5,     1,     1,     1,     5,     5,     1,
       1,     1,     3,     2,     2,     1,     1,     3,     3,     1,
       3,     1,     3,     4,     5,     1,     3,     1,     2,     1,
       1,     3,     1,     3,     2,     3,     3,     2,     3,     1,
       3,     5,     1,     3,     3,     3,     5,     5,     1,     1,
       1,     2,     3,     4,     5,     5,     1,     2,     3,     4,
       4,     4,     4,     5,     2,     2,     1,     2,     3,     1,
       2,     1,     1,     1,     1,     4,     5,     5,     6,     1,
       3,     1,     3,     1,     1,     3,     3,     5,     2,     3,
       3,     4,     3,     2,     3,     3,     3,     3,     1,     1,
       1,     1,     1
};


/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none).  */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM.  */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0
};

/* YYIMMEDIATE[RULE-NUM] -- True iff rule #RULE-NUM is not to be deferred, as
   in the case of predicates.  */
static const yybool yyimmediate[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned char yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     9,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     0,     7,     0,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      11,     0,     0,     0,     0,     0,     0,     0,     0,    25,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,    41,     0,
       0,     0,     0,     0,    21,     0,    23,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,    88,     0,   123,     0,    90,     0,    90,     0,    29,
       0,    59,     0,    65,     0,    22,     0,    91,     0,    32,
       0,    54,     0,    53,     0,   141,     0,    24,     0,   125,
       0,    40,     0,    33,     0,   123,     0,    80,     0,   115,
       0,   116,     0
};

/* Error token number */
#define YYTERROR 1


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

# define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)



#undef yynerrs
#define yynerrs (yystackp->yyerrcnt)
#undef yychar
#define yychar (yystackp->yyrawchar)
#undef yylval
#define yylval (yystackp->yyval)
#undef yylloc
#define yylloc (yystackp->yyloc)


static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)                              \
  do {                                          \
    YYRESULTTAG yychk_flag = YYE;               \
    if (yychk_flag != yyok)                     \
      return yychk_flag;                        \
  } while (0)

#if YYDEBUG

# ifndef YYFPRINTF
#  define YYFPRINTF fprintf
# endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YYDPRINTF(Args)                        \
  do {                                          \
    if (yydebug)                                \
      YYFPRINTF Args;                           \
  } while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, parser, scanner);
  YYFPRINTF (yyoutput, ")");
}

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                  \
  do {                                                                  \
    if (yydebug)                                                        \
      {                                                                 \
        YYFPRINTF (stderr, "%s ", Title);                               \
        yy_symbol_print (stderr, Type, Value, Location, parser, scanner);        \
        YYFPRINTF (stderr, "\n");                                       \
      }                                                                 \
  } while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

struct yyGLRStack;
static void yypstack (struct yyGLRStack* yystackp, size_t yyk)
  YY_ATTRIBUTE_UNUSED;
static void yypdumpstack (struct yyGLRStack* yystackp)
  YY_ATTRIBUTE_UNUSED;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call yyexpandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data.  */
#define YYHEADROOM 2

#ifndef YYSTACKEXPANDABLE
#  define YYSTACKEXPANDABLE 1
#endif

#if YYSTACKEXPANDABLE
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyexpandGLRStack (Yystack);                       \
  } while (0)
#else
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyMemoryExhausted (Yystack);                      \
  } while (0)
#endif


#if YYERROR_VERBOSE

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static size_t
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return strlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* !YYERROR_VERBOSE */

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yyGLRStateSet yyGLRStateSet;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;

struct yyGLRState {
  /** Type tag: always true.  */
  yybool yyisState;
  /** Type tag for yysemantics.  If true, yysval applies, otherwise
   *  yyfirstVal applies.  */
  yybool yyresolved;
  /** Number of corresponding LALR(1) machine state.  */
  yyStateNum yylrState;
  /** Preceding state in this stack */
  yyGLRState* yypred;
  /** Source position of the last token produced by my symbol */
  size_t yyposn;
  union {
    /** First in a chain of alternative reductions producing the
     *  non-terminal corresponding to this state, threaded through
     *  yynext.  */
    yySemanticOption* yyfirstVal;
    /** Semantic value for this state.  */
    YYSTYPE yysval;
  } yysemantics;
  /** Source location for this state.  */
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  /** During nondeterministic operation, yylookaheadNeeds tracks which
   *  stacks have actually needed the current lookahead.  During deterministic
   *  operation, yylookaheadNeeds[0] is not maintained since it would merely
   *  duplicate yychar != YYEMPTY.  */
  yybool* yylookaheadNeeds;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  /** Type tag: always false.  */
  yybool yyisState;
  /** Rule number for this reduction */
  yyRuleNum yyrule;
  /** The last RHS state in the list of states to be reduced.  */
  yyGLRState* yystate;
  /** The lookahead for this reduction.  */
  int yyrawchar;
  YYSTYPE yyval;
  YYLTYPE yyloc;
  /** Next sibling in chain of options.  To facilitate merging,
   *  options are chained in decreasing order by address.  */
  yySemanticOption* yynext;
};

/** Type of the items in the GLR stack.  The yyisState field
 *  indicates which item of the union is valid.  */
union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  int yyerrcnt;
  int yyrawchar;
  YYSTYPE yyval;
  YYLTYPE yyloc;

  YYJMP_BUF yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  size_t yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

#if YYSTACKEXPANDABLE
static void yyexpandGLRStack (yyGLRStack* yystackp);
#endif

static _Noreturn void
yyFail (yyGLRStack* yystackp, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner, const char* yymsg)
{
  if (yymsg != YY_NULLPTR)
    yyerror (yylocp, parser, scanner, yymsg);
  YYLONGJMP (yystackp->yyexception_buffer, 1);
}

static _Noreturn void
yyMemoryExhausted (yyGLRStack* yystackp)
{
  YYLONGJMP (yystackp->yyexception_buffer, 2);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain.  */
static void yyfillin (yyGLRStackItem *, int, int) YY_ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  int i;
  yyGLRState *s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
#if YYDEBUG
      yyvsp[i].yystate.yylrState = s->yylrState;
#endif
      yyvsp[i].yystate.yyresolved = s->yyresolved;
      if (s->yyresolved)
        yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      else
        /* The effect of using yysval or yyloc (in an immediate rule) is
         * undefined.  */
        yyvsp[i].yystate.yysemantics.yyfirstVal = YY_NULLPTR;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
 * YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
 * For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     YY_ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$).  Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT.  */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, size_t yyrhslen, yyGLRStackItem* yyvsp,
              yyGLRStack* yystackp,
              YYSTYPE* yyvalp, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  yybool yynormal YY_ATTRIBUTE_UNUSED = (yystackp->yysplitPoint == YY_NULLPTR);
  int yylow;
  YYUSE (yyvalp);
  YYUSE (yylocp);
  YYUSE (parser);
  YYUSE (scanner);
  YYUSE (yyrhslen);
# undef yyerrok
# define yyerrok (yystackp->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING() (yystackp->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)                                              \
  return yyerror (yylocp, parser, scanner, YY_("syntax error: cannot back up")),     \
         yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT ((*yylocp), (yyvsp - yyrhslen), yyrhslen);
  yystackp->yyerror_range[1].yystate.yyloc = *yylocp;

  switch (yyn)
    {
        case 2:
#line 233 "openinghoursparser.y" /* glr.c:816  */
    { parser->addRule((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule)); }
#line 1199 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 3:
#line 234 "openinghoursparser.y" /* glr.c:816  */
    { parser->addRule((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule)); }
#line 1205 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 4:
#line 235 "openinghoursparser.y" /* glr.c:816  */
    {
    (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule)->m_ruleType = Rule::AdditionalRule;
    parser->addRule((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule));
  }
#line 1214 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 5:
#line 239 "openinghoursparser.y" /* glr.c:816  */
    {
    (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule)->m_ruleType = Rule::FallbackRule;
    parser->addRule((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.rule));
  }
#line 1223 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 6:
#line 243 "openinghoursparser.y" /* glr.c:816  */
    {
    if (!parser->isRecovering()) {
        parser->restartFrom((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc).first_column, Rule::NormalRule);
        parser->m_ruleSeparatorRecovery = true;
        yyerrok;
    } else {
        YYERROR;
    }
  }
#line 1237 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 7:
#line 252 "openinghoursparser.y" /* glr.c:816  */
    {
    if (!parser->isRecovering()) {
        parser->restartFrom((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc).first_column, Rule::GuessRuleType);
        parser->m_ruleSeparatorRecovery = true;
        yyerrok;
    } else {
        YYERROR;
    }
  }
#line 1251 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 8:
#line 264 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    applySelectors((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors), ((*yyvalp).rule));
  }
#line 1260 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 9:
#line 268 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setComment((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).str, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).len);
    applySelectors((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors), ((*yyvalp).rule));
  }
#line 1270 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 10:
#line 273 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setState((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.state));
    applySelectors((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors), ((*yyvalp).rule));
  }
#line 1280 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 11:
#line 278 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setComment((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).str, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).len);
    ((*yyvalp).rule)->setState((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.state));
    applySelectors((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors), ((*yyvalp).rule));
  }
#line 1291 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 12:
#line 284 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setComment((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).str, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).len);
  }
#line 1300 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 13:
#line 288 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setState((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.state));
  }
#line 1309 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 14:
#line 292 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).rule) = new Rule;
    ((*yyvalp).rule)->setComment((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).str, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.strRef).len);
    ((*yyvalp).rule)->setState((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.state));
  }
#line 1319 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 15:
#line 300 "openinghoursparser.y" /* glr.c:816  */
    { initSelectors(((*yyvalp).selectors)); ((*yyvalp).selectors).seen_24_7 = true; }
#line 1325 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 16:
#line 301 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1331 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 17:
#line 302 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1337 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 18:
#line 303 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors);
    ((*yyvalp).selectors).colonAfterWideRangeSelector = true;
  }
#line 1346 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 19:
#line 307 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).timeSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).timeSelector;
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).weekdaySelector;
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).weekSelector;
  }
#line 1356 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 20:
#line 312 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).timeSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).timeSelector;
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).weekdaySelector;
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors).weekSelector;
    ((*yyvalp).selectors).colonAfterWideRangeSelector = true;
  }
#line 1367 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 21:
#line 321 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1373 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 22:
#line 322 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1379 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 23:
#line 323 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1385 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 24:
#line 324 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).yearSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).yearSelector;
    ((*yyvalp).selectors).monthdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).monthdaySelector;
}
#line 1394 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 25:
#line 328 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).yearSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).yearSelector;
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).weekSelector;
  }
#line 1403 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 26:
#line 332 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).monthdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).monthdaySelector;
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).weekSelector;
  }
#line 1412 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 27:
#line 336 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).yearSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors).yearSelector;
    ((*yyvalp).selectors).monthdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).monthdaySelector;
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).weekSelector;
  }
#line 1422 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 28:
#line 341 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).wideRangeSelectorComment = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.strRef);
    ((*yyvalp).selectors).colonAfterWideRangeSelector = true;
  }
#line 1432 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 29:
#line 349 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1438 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 30:
#line 350 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors); }
#line 1444 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 31:
#line 351 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors); }
#line 1450 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 32:
#line 352 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).timeSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).timeSelector;
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.selectors).weekdaySelector;
  }
#line 1459 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 33:
#line 356 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors).timeSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.selectors).timeSelector;
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors).weekdaySelector;
  }
#line 1468 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 34:
#line 364 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).timeSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.timespan);
  }
#line 1477 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 35:
#line 368 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    appendSelector(((*yyvalp).selectors).timeSelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.timespan));
  }
#line 1486 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 36:
#line 372 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    parser->restartFrom((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc).first_column, Rule::AdditionalRule);
    yyerrok;
  }
#line 1496 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 37:
#line 377 "openinghoursparser.y" /* glr.c:816  */
    { /* wrong use of slash as a timespan separator */
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.selectors);
    parser->restartFrom((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yyloc).first_column, Rule::AdditionalRule);
    yyerrok;
  }
#line 1506 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 38:
#line 385 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->pointInTime = true;
  }
#line 1516 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 39:
#line 390 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->pointInTime = true;
    ((*yyvalp).timespan)->openEnd = true;
  }
#line 1527 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 40:
#line 396 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time);
  }
#line 1537 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 41:
#line 401 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->openEnd = true;
  }
#line 1548 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 42:
#line 407 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->interval = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1559 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 43:
#line 413 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).timespan) = new Timespan;
    ((*yyvalp).timespan)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.time);
    ((*yyvalp).timespan)->interval = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time).hour * 60 + (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time).minute;
  }
#line 1570 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 44:
#line 422 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).time) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time); }
#line 1576 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 45:
#line 423 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).time) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time); }
#line 1582 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 46:
#line 427 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).time) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.time); }
#line 1588 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 47:
#line 428 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.time);
    ((*yyvalp).time).hour = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time).hour;
    ((*yyvalp).time).minute = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time).minute;
  }
#line 1598 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 48:
#line 433 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.time);
    ((*yyvalp).time).hour = -(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time).hour;
    ((*yyvalp).time).minute = -(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.time).minute;
  }
#line 1608 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 49:
#line 442 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange);
  }
#line 1617 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 50:
#line 446 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).weekdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange);
  }
#line 1626 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 51:
#line 453 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange); }
#line 1632 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 52:
#line 454 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.weekdayRange);
    appendSelector(((*yyvalp).weekdayRange), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1641 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 53:
#line 461 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->lhsAndSelector.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.weekdayRange));
    ((*yyvalp).weekdayRange)->rhsAndSelector.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1651 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 54:
#line 466 "openinghoursparser.y" /* glr.c:816  */
    { // wrong order according to the specification
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->lhsAndSelector.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
    ((*yyvalp).weekdayRange)->rhsAndSelector.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1661 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 55:
#line 474 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange); }
#line 1667 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 56:
#line 475 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange); }
#line 1673 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 57:
#line 476 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.weekdayRange);
    appendSelector(((*yyvalp).weekdayRange), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1682 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 58:
#line 480 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.weekdayRange);
    appendSelector(((*yyvalp).weekdayRange), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1691 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 59:
#line 487 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange); }
#line 1697 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 60:
#line 488 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.weekdayRange);
    appendSelector(((*yyvalp).weekdayRange), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange));
  }
#line 1706 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 61:
#line 495 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->beginDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
    ((*yyvalp).weekdayRange)->endDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1716 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 62:
#line 500 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->beginDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    ((*yyvalp).weekdayRange)->endDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1726 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 63:
#line 505 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->beginDay = ((*yyvalp).weekdayRange)->endDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num);
    ((*yyvalp).weekdayRange)->nthSequence.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.nthSequence));
  }
#line 1736 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 64:
#line 510 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->beginDay = ((*yyvalp).weekdayRange)->endDay = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num);
    ((*yyvalp).weekdayRange)->nthSequence.reset((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.nthSequence));
    ((*yyvalp).weekdayRange)->offset = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1747 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 65:
#line 519 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange); }
#line 1753 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 66:
#line 520 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).weekdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.weekdayRange); appendSelector(((*yyvalp).weekdayRange), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.weekdayRange)); }
#line 1759 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 67:
#line 524 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->holiday = WeekdayRange::PublicHoliday;
  }
#line 1768 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 68:
#line 528 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->holiday = WeekdayRange::PublicHoliday;
    ((*yyvalp).weekdayRange)->offset = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1778 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 69:
#line 533 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).weekdayRange) = new WeekdayRange;
    ((*yyvalp).weekdayRange)->holiday = WeekdayRange::SchoolHoliday;
  }
#line 1787 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 70:
#line 540 "openinghoursparser.y" /* glr.c:816  */
    {
      ((*yyvalp).nthSequence) = new NthSequence;
      ((*yyvalp).nthSequence)->add((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.nthEntry));
  }
#line 1796 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 71:
#line 544 "openinghoursparser.y" /* glr.c:816  */
    {
      (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.nthSequence)->add((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.nthEntry));
      ((*yyvalp).nthSequence) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.nthSequence);
  }
#line 1805 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 72:
#line 550 "openinghoursparser.y" /* glr.c:816  */
    {
    if ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) < 1 || (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) > 5) { YYABORT; }
    ((*yyvalp).nthEntry) = {(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num),(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num)};
  }
#line 1814 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 73:
#line 554 "openinghoursparser.y" /* glr.c:816  */
    {
    if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num) < 1 || (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num) > 5 || (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) < 1 || (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) > 5 || (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) <= (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num)) { YYABORT; }
    ((*yyvalp).nthEntry) = {(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num),(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num)};
  }
#line 1823 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 74:
#line 558 "openinghoursparser.y" /* glr.c:816  */
    {
    if ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) < 1 || (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) > 5) { YYABORT; }
    ((*yyvalp).nthEntry) = {-(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num),-(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num)};
  }
#line 1832 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 75:
#line 565 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).num) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num); }
#line 1838 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 76:
#line 566 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).num) = -(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num); }
#line 1844 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 77:
#line 571 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).weekSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.week);
  }
#line 1853 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 78:
#line 575 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    appendSelector(((*yyvalp).selectors).weekSelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.week));
  }
#line 1862 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 79:
#line 582 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).week) = new Week;
    ((*yyvalp).week)->beginWeek = ((*yyvalp).week)->endWeek = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1871 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 80:
#line 586 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).week) = new Week;
    ((*yyvalp).week)->beginWeek = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    ((*yyvalp).week)->endWeek = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1881 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 81:
#line 591 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).week) = new Week;
    ((*yyvalp).week)->beginWeek = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num);
    ((*yyvalp).week)->endWeek = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    ((*yyvalp).week)->interval = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 1892 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 82:
#line 603 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).monthdaySelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.monthdayRange);
  }
#line 1901 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 83:
#line 607 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    appendSelector(((*yyvalp).selectors).monthdaySelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.monthdayRange));
  }
#line 1910 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 84:
#line 611 "openinghoursparser.y" /* glr.c:816  */
    {
    // month day sets, not covered the official grammar but in the
    // description in https://wiki.openstreetmap.org/wiki/Key:opening_hours#Summary_syntax
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    if (!extendMonthdaySelector(((*yyvalp).selectors).monthdaySelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num))) {
        delete ((*yyvalp).selectors).monthdaySelector;
        YYABORT;
    }
  }
#line 1924 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 85:
#line 620 "openinghoursparser.y" /* glr.c:816  */
    {
    // same as the above, just with the wrong ", " separator
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    if (!extendMonthdaySelector(((*yyvalp).selectors).monthdaySelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num))) {
        delete ((*yyvalp).selectors).monthdaySelector;
        YYABORT;
    }
  }
#line 1937 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 86:
#line 628 "openinghoursparser.y" /* glr.c:816  */
    {
    // same with a range of days
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.selectors);
    if (!extendMonthdaySelector(((*yyvalp).selectors).monthdaySelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num))) {
        delete ((*yyvalp).selectors).monthdaySelector;
        YYABORT;
    }
  }
#line 1950 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 87:
#line 636 "openinghoursparser.y" /* glr.c:816  */
    {
    // same as the above, just with the wrong ", " separator
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.selectors);
    if (!extendMonthdaySelector(((*yyvalp).selectors).monthdaySelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num))) {
        delete ((*yyvalp).selectors).monthdaySelector;
        YYABORT;
    }
  }
#line 1963 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 88:
#line 647 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = ((*yyvalp).monthdayRange)->end = { (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 1972 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 89:
#line 651 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).monthdayRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.monthdayRange); }
#line 1978 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 90:
#line 654 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = ((*yyvalp).monthdayRange)->end = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 1987 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 91:
#line 658 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = ((*yyvalp).monthdayRange)->end = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 1996 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 92:
#line 662 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
    ((*yyvalp).monthdayRange)->end = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 2006 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 93:
#line 667 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
    ((*yyvalp).monthdayRange)->end = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 2016 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 94:
#line 672 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
    ((*yyvalp).monthdayRange)->end = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, { 0, 0, 0 } };
  }
#line 2026 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 95:
#line 677 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.dateOffset) };
    ((*yyvalp).monthdayRange)->end = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dateOffset) };
  }
#line 2036 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 96:
#line 682 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date);
  }
#line 2045 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 97:
#line 686 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->begin.offset += (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dateOffset);
    ((*yyvalp).monthdayRange)->end = ((*yyvalp).monthdayRange)->begin;
  }
#line 2056 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 98:
#line 692 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date);
    if (((*yyvalp).monthdayRange)->end.year == 0) { ((*yyvalp).monthdayRange)->end.year = ((*yyvalp).monthdayRange)->begin.year; }
    if (((*yyvalp).monthdayRange)->end.month == 0) { ((*yyvalp).monthdayRange)->end.month = ((*yyvalp).monthdayRange)->begin.month; }
  }
#line 2068 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 99:
#line 699 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->begin.offset += (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.dateOffset);
    ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date);
    if (((*yyvalp).monthdayRange)->end.year == 0) { ((*yyvalp).monthdayRange)->end.year = ((*yyvalp).monthdayRange)->begin.year; }
    if (((*yyvalp).monthdayRange)->end.month == 0) { ((*yyvalp).monthdayRange)->end.month = ((*yyvalp).monthdayRange)->begin.month; }
  }
#line 2081 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 100:
#line 707 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.date);
    if (((*yyvalp).monthdayRange)->end.year == 0) { ((*yyvalp).monthdayRange)->end.year = ((*yyvalp).monthdayRange)->begin.year; }
    if (((*yyvalp).monthdayRange)->end.month == 0) { ((*yyvalp).monthdayRange)->end.month = ((*yyvalp).monthdayRange)->begin.month; }
    ((*yyvalp).monthdayRange)->end.offset += (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dateOffset);
  }
#line 2094 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 101:
#line 715 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->end = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.date).year, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dateOffset) };
  }
#line 2104 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 102:
#line 720 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), 0, Date::FixedDate, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.dateOffset) };
    ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date);
  }
#line 2114 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 103:
#line 725 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).monthdayRange) = new MonthdayRange;
    ((*yyvalp).monthdayRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.date);
    ((*yyvalp).monthdayRange)->begin.offset += (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.dateOffset);
    ((*yyvalp).monthdayRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.date);
    if (((*yyvalp).monthdayRange)->end.year == 0) { ((*yyvalp).monthdayRange)->end.year = ((*yyvalp).monthdayRange)->begin.year; }
    if (((*yyvalp).monthdayRange)->end.month == 0) { ((*yyvalp).monthdayRange)->end.month = ((*yyvalp).monthdayRange)->begin.month; }
    ((*yyvalp).monthdayRange)->end.offset += (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dateOffset);
  }
#line 2128 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 104:
#line 737 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { 0, (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 1 }; }
#line 2134 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 105:
#line 738 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { 0, (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), -1 }; }
#line 2140 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 106:
#line 739 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { (int16_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0, 0 }; }
#line 2146 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 107:
#line 743 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = { 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), Date::FixedDate, { 0, 0, 0 } }; }
#line 2152 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 108:
#line 744 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = { (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), Date::FixedDate, { 0, 0, 0 } }; }
#line 2158 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 109:
#line 745 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date); }
#line 2164 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 110:
#line 746 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).date) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date);
    ((*yyvalp).date).year = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num);
  }
#line 2173 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 111:
#line 753 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.date); }
#line 2179 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 112:
#line 754 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = { 0, 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), Date::FixedDate, { 0, 0, 0 } }; }
#line 2185 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 113:
#line 758 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = { 0, 0, 0, Date::Easter, { 0, 0, 0 } }; }
#line 2191 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 114:
#line 759 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).date) = { 0, 0, 0, Date::Easter, { 49, 0, 0 } }; }
#line 2197 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 115:
#line 763 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { 0, (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num) }; }
#line 2203 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 116:
#line 764 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { 0, (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num), (int8_t)-(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num) }; }
#line 2209 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 117:
#line 765 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { (int16_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num), (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num) }; }
#line 2215 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 118:
#line 766 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).dateOffset) = { (int16_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), (int8_t)(((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.num), (int8_t)-(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num) }; }
#line 2221 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 119:
#line 772 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).yearSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.yearRange);
  }
#line 2230 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 120:
#line 776 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    appendSelector(((*yyvalp).selectors).yearSelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.yearRange));
  }
#line 2239 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 121:
#line 782 "openinghoursparser.y" /* glr.c:816  */
    {
    initSelectors(((*yyvalp).selectors));
    ((*yyvalp).selectors).yearSelector = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.yearRange);
  }
#line 2248 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 122:
#line 786 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).selectors) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.selectors);
    appendSelector(((*yyvalp).selectors).yearSelector, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.yearRange));
  }
#line 2257 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 123:
#line 793 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).yearRange) = new YearRange;
    ((*yyvalp).yearRange)->begin = ((*yyvalp).yearRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 2266 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 124:
#line 797 "openinghoursparser.y" /* glr.c:816  */
    { ((*yyvalp).yearRange) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.yearRange); }
#line 2272 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 125:
#line 801 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).yearRange) = new YearRange;
    ((*yyvalp).yearRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    ((*yyvalp).yearRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
    if (((*yyvalp).yearRange)->end < ((*yyvalp).yearRange)->begin) {
        delete ((*yyvalp).yearRange);
        YYABORT;
    }
  }
#line 2286 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 126:
#line 810 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).yearRange) = new YearRange;
    ((*yyvalp).yearRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    ((*yyvalp).yearRange)->interval = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 2296 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 127:
#line 815 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).yearRange) = new YearRange;
    ((*yyvalp).yearRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.num);
    ((*yyvalp).yearRange)->end = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num);
    if (((*yyvalp).yearRange)->end < ((*yyvalp).yearRange)->begin) {
        delete ((*yyvalp).yearRange);
        YYABORT;
    }
    ((*yyvalp).yearRange)->interval = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num);
  }
#line 2311 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 128:
#line 825 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).yearRange) = new YearRange;
    ((*yyvalp).yearRange)->begin = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num);
  }
#line 2320 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 129:
#line 832 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2329 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 130:
#line 836 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2338 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 131:
#line 840 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num) };
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2347 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 132:
#line 844 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2356 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 133:
#line 848 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.num), 0 };
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2365 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 134:
#line 852 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    Time::convertFromAm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2375 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 135:
#line 857 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    Time::convertFromAm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2385 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 136:
#line 862 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    Time::convertFromPm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2395 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 137:
#line 867 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.num), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) };
    Time::convertFromPm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2405 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 138:
#line 872 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0 };
    Time::convertFromAm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2415 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 139:
#line 877 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num), 0 };
    Time::convertFromPm(((*yyvalp).time));
    if (!Time::isValid(((*yyvalp).time))) { YYABORT; }
  }
#line 2425 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;

  case 140:
#line 882 "openinghoursparser.y" /* glr.c:816  */
    {
    ((*yyvalp).time) = { Time::NoEvent, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) / 100, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num) % 100 }; // lexer ensures this is always a valid time
}
#line 2433 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
    break;


#line 2437 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:816  */
      default: break;
    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  YYUSE (yy0);
  YYUSE (yy1);

  switch (yyn)
    {

      default: break;
    }
}

                              /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 38: /* Rule  */
#line 208 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).rule); }
#line 2488 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 39: /* SelectorSequence  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2500 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 40: /* WideRangeSelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2512 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 41: /* SmallRangeSelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2524 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 42: /* TimeSelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2536 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 43: /* Timespan  */
#line 216 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).timespan); }
#line 2542 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 46: /* WeekdaySelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2554 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 47: /* HolidayAndWeekdaySequence  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2560 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 48: /* HolidayAndWeekday  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2566 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 49: /* HolidayOrWeekdaySequence  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2572 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 50: /* WeekdaySequence  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2578 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 51: /* WeekdayRange  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2584 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 52: /* HolidaySequence  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2590 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 53: /* Holiday  */
#line 218 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).weekdayRange); }
#line 2596 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 54: /* NthSequence  */
#line 217 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).nthSequence); }
#line 2602 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 57: /* WeekSelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2614 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 58: /* Week  */
#line 219 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).week); }
#line 2620 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 59: /* MonthdaySelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2632 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 60: /* MonthdayRange  */
#line 220 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).monthdayRange); }
#line 2638 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 61: /* MonthdayRangeAdditional  */
#line 220 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).monthdayRange); }
#line 2644 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 67: /* YearSelector  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2656 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 68: /* YearSelectorCombined  */
#line 209 "openinghoursparser.y" /* glr.c:846  */
      {
    delete ((*yyvaluep).selectors).timeSelector;
    delete ((*yyvaluep).selectors).weekdaySelector;
    delete ((*yyvaluep).selectors).weekSelector;
    delete ((*yyvaluep).selectors).monthdaySelector;
    delete ((*yyvaluep).selectors).yearSelector;
}
#line 2668 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 69: /* YearRange  */
#line 221 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).yearRange); }
#line 2674 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;

    case 70: /* YearRangeStandalone  */
#line 221 "openinghoursparser.y" /* glr.c:846  */
      { delete ((*yyvaluep).yearRange); }
#line 2680 "/home/abuild/rpmbuild/BUILD/kopeninghours-22.12.3/build/src/lib/openinghoursparser.cpp" /* glr.c:846  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}

/** Number of symbols composing the right hand side of rule #RULE.  */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

static void
yydestroyGLRState (char const *yymsg, yyGLRState *yys, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  if (yys->yyresolved)
    yydestruct (yymsg, yystos[yys->yylrState],
                &yys->yysemantics.yysval, &yys->yyloc, parser, scanner);
  else
    {
#if YYDEBUG
      if (yydebug)
        {
          if (yys->yysemantics.yyfirstVal)
            YYFPRINTF (stderr, "%s unresolved", yymsg);
          else
            YYFPRINTF (stderr, "%s incomplete", yymsg);
          YY_SYMBOL_PRINT ("", yystos[yys->yylrState], YY_NULLPTR, &yys->yyloc);
        }
#endif

      if (yys->yysemantics.yyfirstVal)
        {
          yySemanticOption *yyoption = yys->yysemantics.yyfirstVal;
          yyGLRState *yyrh;
          int yyn;
          for (yyrh = yyoption->yystate, yyn = yyrhsLength (yyoption->yyrule);
               yyn > 0;
               yyrh = yyrh->yypred, yyn -= 1)
            yydestroyGLRState (yymsg, yyrh, parser, scanner);
        }
    }
}

/** Left-hand-side symbol for rule #YYRULE.  */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-143)))

/** True iff LR state YYSTATE has only a default reduction (regardless
 *  of token).  */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yypact_value_is_default (yypact[yystate]);
}

/** The default reduction for YYSTATE, assuming it has one.  */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yytable_value_is_error(Yytable_value) \
  0

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *YYCONFLICTS to a pointer into yyconfl to a 0-terminated list
 *  of conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
                int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yypact_value_is_default (yypact[yystate])
      || yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yytable_value_is_error (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

/** Compute post-reduction state.
 * \param yystate   the current state
 * \param yysym     the nonterminal to push on the stack
 */
static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yysym)
{
  int yyr = yypgoto[yysym - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yysym - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

                                /* GLRStates */

/** Return a fresh GLRStackItem in YYSTACKP.  The item is an LR state
 *  if YYISSTATE, and otherwise a semantic option.  Callers should call
 *  YY_RESERVE_GLRSTACK afterwards to make sure there is sufficient
 *  headroom.  */

static inline yyGLRStackItem*
yynewGLRStackItem (yyGLRStack* yystackp, yybool yyisState)
{
  yyGLRStackItem* yynewItem = yystackp->yynextFree;
  yystackp->yyspaceLeft -= 1;
  yystackp->yynextFree += 1;
  yynewItem->yystate.yyisState = yyisState;
  return yynewItem;
}

/** Add a new semantic action that will execute the action for rule
 *  YYRULE on the semantic values in YYRHS to the list of
 *  alternative actions for YYSTATE.  Assumes that YYRHS comes from
 *  stack #YYK of *YYSTACKP. */
static void
yyaddDeferredAction (yyGLRStack* yystackp, size_t yyk, yyGLRState* yystate,
                     yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewOption =
    &yynewGLRStackItem (yystackp, yyfalse)->yyoption;
  YYASSERT (!yynewOption->yyisState);
  yynewOption->yystate = yyrhs;
  yynewOption->yyrule = yyrule;
  if (yystackp->yytops.yylookaheadNeeds[yyk])
    {
      yynewOption->yyrawchar = yychar;
      yynewOption->yyval = yylval;
      yynewOption->yyloc = yylloc;
    }
  else
    yynewOption->yyrawchar = YYEMPTY;
  yynewOption->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewOption;

  YY_RESERVE_GLRSTACK (yystackp);
}

                                /* GLRStacks */

/** Initialize YYSET to a singleton set containing an empty stack.  */
static yybool
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  if (! yyset->yystates)
    return yyfalse;
  yyset->yystates[0] = YY_NULLPTR;
  yyset->yylookaheadNeeds =
    (yybool*) YYMALLOC (16 * sizeof yyset->yylookaheadNeeds[0]);
  if (! yyset->yylookaheadNeeds)
    {
      YYFREE (yyset->yystates);
      return yyfalse;
    }
  return yytrue;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
  YYFREE (yyset->yylookaheadNeeds);
}

/** Initialize *YYSTACKP to a single empty stack, with total maximum
 *  capacity for all stacks of YYSIZE.  */
static yybool
yyinitGLRStack (yyGLRStack* yystackp, size_t yysize)
{
  yystackp->yyerrState = 0;
  yynerrs = 0;
  yystackp->yyspaceLeft = yysize;
  yystackp->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystackp->yynextFree[0]);
  if (!yystackp->yyitems)
    return yyfalse;
  yystackp->yynextFree = yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;
  return yyinitStateSet (&yystackp->yytops);
}


#if YYSTACKEXPANDABLE
# define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If *YYSTACKP is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation.  */
static void
yyexpandGLRStack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yynewItems;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yynewSize;
  size_t yyn;
  size_t yysize = yystackp->yynextFree - yystackp->yyitems;
  if (YYMAXDEPTH - YYHEADROOM < yysize)
    yyMemoryExhausted (yystackp);
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yynewItems = (yyGLRStackItem*) YYMALLOC (yynewSize * sizeof yynewItems[0]);
  if (! yynewItems)
    yyMemoryExhausted (yystackp);
  for (yyp0 = yystackp->yyitems, yyp1 = yynewItems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
        {
          yyGLRState* yys0 = &yyp0->yystate;
          yyGLRState* yys1 = &yyp1->yystate;
          if (yys0->yypred != YY_NULLPTR)
            yys1->yypred =
              YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
          if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != YY_NULLPTR)
            yys1->yysemantics.yyfirstVal =
              YYRELOC (yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
        }
      else
        {
          yySemanticOption* yyv0 = &yyp0->yyoption;
          yySemanticOption* yyv1 = &yyp1->yyoption;
          if (yyv0->yystate != YY_NULLPTR)
            yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
          if (yyv0->yynext != YY_NULLPTR)
            yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
        }
    }
  if (yystackp->yysplitPoint != YY_NULLPTR)
    yystackp->yysplitPoint = YYRELOC (yystackp->yyitems, yynewItems,
                                      yystackp->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystackp->yytops.yysize; yyn += 1)
    if (yystackp->yytops.yystates[yyn] != YY_NULLPTR)
      yystackp->yytops.yystates[yyn] =
        YYRELOC (yystackp->yyitems, yynewItems,
                 yystackp->yytops.yystates[yyn], yystate);
  YYFREE (yystackp->yyitems);
  yystackp->yyitems = yynewItems;
  yystackp->yynextFree = yynewItems + yysize;
  yystackp->yyspaceLeft = yynewSize - yysize;
}
#endif

static void
yyfreeGLRStack (yyGLRStack* yystackp)
{
  YYFREE (yystackp->yyitems);
  yyfreeStateSet (&yystackp->yytops);
}

/** Assuming that YYS is a GLRState somewhere on *YYSTACKP, update the
 *  splitpoint of *YYSTACKP, if needed, so that it is at least as deep as
 *  YYS.  */
static inline void
yyupdateSplit (yyGLRStack* yystackp, yyGLRState* yys)
{
  if (yystackp->yysplitPoint != YY_NULLPTR && yystackp->yysplitPoint > yys)
    yystackp->yysplitPoint = yys;
}

/** Invalidate stack #YYK in *YYSTACKP.  */
static inline void
yymarkStackDeleted (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    yystackp->yylastDeleted = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yystates[yyk] = YY_NULLPTR;
}

/** Undelete the last stack in *YYSTACKP that was marked as deleted.  Can
    only be done once after a deletion, and only when all other stacks have
    been deleted.  */
static void
yyundeleteLastStack (yyGLRStack* yystackp)
{
  if (yystackp->yylastDeleted == YY_NULLPTR || yystackp->yytops.yysize != 0)
    return;
  yystackp->yytops.yystates[0] = yystackp->yylastDeleted;
  yystackp->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystackp->yylastDeleted = YY_NULLPTR;
}

static inline void
yyremoveDeletes (yyGLRStack* yystackp)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystackp->yytops.yysize)
    {
      if (yystackp->yytops.yystates[yyi] == YY_NULLPTR)
        {
          if (yyi == yyj)
            {
              YYDPRINTF ((stderr, "Removing dead stacks.\n"));
            }
          yystackp->yytops.yysize -= 1;
        }
      else
        {
          yystackp->yytops.yystates[yyj] = yystackp->yytops.yystates[yyi];
          /* In the current implementation, it's unnecessary to copy
             yystackp->yytops.yylookaheadNeeds[yyi] since, after
             yyremoveDeletes returns, the parser immediately either enters
             deterministic operation or shifts a token.  However, it doesn't
             hurt, and the code might evolve to need it.  */
          yystackp->yytops.yylookaheadNeeds[yyj] =
            yystackp->yytops.yylookaheadNeeds[yyi];
          if (yyj != yyi)
            {
              YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
                          (unsigned long int) yyi, (unsigned long int) yyj));
            }
          yyj += 1;
        }
      yyi += 1;
    }
}

/** Shift to a new state on stack #YYK of *YYSTACKP, corresponding to LR
 * state YYLRSTATE, at input position YYPOSN, with (resolved) semantic
 * value *YYVALP and source location *YYLOCP.  */
static inline void
yyglrShift (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
            size_t yyposn,
            YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yytrue;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yysval = *yyvalp;
  yynewState->yyloc = *yylocp;
  yystackp->yytops.yystates[yyk] = yynewState;

  YY_RESERVE_GLRSTACK (yystackp);
}

/** Shift stack #YYK of *YYSTACKP, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE.  */
static inline void
yyglrShiftDefer (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
                 size_t yyposn, yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;
  YYASSERT (yynewState->yyisState);

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yyfalse;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yyfirstVal = YY_NULLPTR;
  yystackp->yytops.yystates[yyk] = yynewState;

  /* Invokes YY_RESERVE_GLRSTACK.  */
  yyaddDeferredAction (yystackp, yyk, yynewState, yyrhs, yyrule);
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(Args)
#else
# define YY_REDUCE_PRINT(Args)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print Args;               \
} while (0)

/*----------------------------------------------------------------------.
| Report that stack #YYK of *YYSTACKP is going to be reduced by YYRULE. |
`----------------------------------------------------------------------*/

static inline void
yy_reduce_print (int yynormal, yyGLRStackItem* yyvsp, size_t yyk,
                 yyRuleNum yyrule, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  int yynrhs = yyrhsLength (yyrule);
  int yylow = 1;
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu):\n",
             (unsigned long int) yyk, yyrule - 1,
             (unsigned long int) yyrline[yyrule]);
  if (! yynormal)
    yyfillin (yyvsp, 1, -yynrhs);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyvsp[yyi - yynrhs + 1].yystate.yylrState],
                       &yyvsp[yyi - yynrhs + 1].yystate.yysemantics.yysval
                       , &(((yyGLRStackItem const *)yyvsp)[YYFILL ((yyi + 1) - (yynrhs))].yystate.yyloc)                       , parser, scanner);
      if (!yyvsp[yyi - yynrhs + 1].yystate.yyresolved)
        YYFPRINTF (stderr, " (unresolved)");
      YYFPRINTF (stderr, "\n");
    }
}
#endif

/** Pop the symbols consumed by reduction #YYRULE from the top of stack
 *  #YYK of *YYSTACKP, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved.  Set *YYVALP to the resulting value,
 *  and *YYLOCP to the computed location (if any).  Return value is as
 *  for userAction.  */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
            YYSTYPE* yyvalp, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      /* Standard special case: single stack.  */
      yyGLRStackItem* yyrhs = (yyGLRStackItem*) yystackp->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystackp->yynextFree -= yynrhs;
      yystackp->yyspaceLeft += yynrhs;
      yystackp->yytops.yystates[0] = & yystackp->yynextFree[-1].yystate;
      YY_REDUCE_PRINT ((1, yyrhs, yyk, yyrule, parser, scanner));
      return yyuserAction (yyrule, yynrhs, yyrhs, yystackp,
                           yyvalp, yylocp, parser, scanner);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
        = yystackp->yytops.yystates[yyk];
      if (yynrhs == 0)
        /* Set default location.  */
        yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yys->yyloc;
      for (yyi = 0; yyi < yynrhs; yyi += 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yystackp->yytops.yystates[yyk] = yys;
      YY_REDUCE_PRINT ((0, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1, yyk, yyrule, parser, scanner));
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp, parser, scanner);
    }
}

/** Pop items off stack #YYK of *YYSTACKP according to grammar rule YYRULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with YYRULE and store its value with the
 *  newly pushed state, if YYFORCEEVAL or if *YYSTACKP is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #YYK from
 *  *YYSTACKP.  In this case, the semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  size_t yyposn = yystackp->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YYRESULTTAG yyflag = yydoAction (yystackp, yyk, yyrule, &yysval, &yyloc, parser, scanner);
      if (yyflag == yyerr && yystackp->yysplitPoint != YY_NULLPTR)
        {
          YYDPRINTF ((stderr, "Parse on stack %lu rejected by rule #%d.\n",
                     (unsigned long int) yyk, yyrule - 1));
        }
      if (yyflag != yyok)
        return yyflag;
      YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyrule], &yysval, &yyloc);
      yyglrShift (yystackp, yyk,
                  yyLRgotoState (yystackp->yytops.yystates[yyk]->yylrState,
                                 yylhsNonterm (yyrule)),
                  yyposn, &yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystackp->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystackp->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
           0 < yyn; yyn -= 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
                  "Reduced stack %lu by rule #%d; action deferred.  "
                  "Now in state %d.\n",
                  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
        if (yyi != yyk && yystackp->yytops.yystates[yyi] != YY_NULLPTR)
          {
            yyGLRState *yysplit = yystackp->yysplitPoint;
            yyGLRState *yyp = yystackp->yytops.yystates[yyi];
            while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
              {
                if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
                  {
                    yyaddDeferredAction (yystackp, yyk, yyp, yys0, yyrule);
                    yymarkStackDeleted (yystackp, yyk);
                    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
                                (unsigned long int) yyk,
                                (unsigned long int) yyi));
                    return yyok;
                  }
                yyp = yyp->yypred;
              }
          }
      yystackp->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystackp, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static size_t
yysplitStack (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYASSERT (yyk == 0);
      yystackp->yysplitPoint = yystackp->yytops.yystates[yyk];
    }
  if (yystackp->yytops.yysize >= yystackp->yytops.yycapacity)
    {
      yyGLRState** yynewStates;
      yybool* yynewLookaheadNeeds;

      yynewStates = YY_NULLPTR;

      if (yystackp->yytops.yycapacity
          > (YYSIZEMAX / (2 * sizeof yynewStates[0])))
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yycapacity *= 2;

      yynewStates =
        (yyGLRState**) YYREALLOC (yystackp->yytops.yystates,
                                  (yystackp->yytops.yycapacity
                                   * sizeof yynewStates[0]));
      if (yynewStates == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yystates = yynewStates;

      yynewLookaheadNeeds =
        (yybool*) YYREALLOC (yystackp->yytops.yylookaheadNeeds,
                             (yystackp->yytops.yycapacity
                              * sizeof yynewLookaheadNeeds[0]));
      if (yynewLookaheadNeeds == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yylookaheadNeeds = yynewLookaheadNeeds;
    }
  yystackp->yytops.yystates[yystackp->yytops.yysize]
    = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yylookaheadNeeds[yystackp->yytops.yysize]
    = yystackp->yytops.yylookaheadNeeds[yyk];
  yystackp->yytops.yysize += 1;
  return yystackp->yytops.yysize-1;
}

/** True iff YYY0 and YYY1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols.  */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
           yyn = yyrhsLength (yyy0->yyrule);
           yyn > 0;
           yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
        if (yys0->yyposn != yys1->yyposn)
          return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (YYY0,YYY1), destructively merge the
 *  alternative semantic values for the RHS-symbols of YYY1 and YYY0.  */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    {
      if (yys0 == yys1)
        break;
      else if (yys0->yyresolved)
        {
          yys1->yyresolved = yytrue;
          yys1->yysemantics.yysval = yys0->yysemantics.yysval;
        }
      else if (yys1->yyresolved)
        {
          yys0->yyresolved = yytrue;
          yys0->yysemantics.yysval = yys1->yysemantics.yysval;
        }
      else
        {
          yySemanticOption** yyz0p = &yys0->yysemantics.yyfirstVal;
          yySemanticOption* yyz1 = yys1->yysemantics.yyfirstVal;
          while (yytrue)
            {
              if (yyz1 == *yyz0p || yyz1 == YY_NULLPTR)
                break;
              else if (*yyz0p == YY_NULLPTR)
                {
                  *yyz0p = yyz1;
                  break;
                }
              else if (*yyz0p < yyz1)
                {
                  yySemanticOption* yyz = *yyz0p;
                  *yyz0p = yyz1;
                  yyz1 = yyz1->yynext;
                  (*yyz0p)->yynext = yyz;
                }
              yyz0p = &(*yyz0p)->yynext;
            }
          yys1->yysemantics.yyfirstVal = yys0->yysemantics.yyfirstVal;
        }
    }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred.  */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
        return 0;
      else
        return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yyGLRState* yys,
                                   yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner);


/** Resolve the previous YYN states starting at and including state YYS
 *  on *YYSTACKP. If result != yyok, some states may have been left
 *  unresolved possibly with empty semantic option chains.  Regardless
 *  of whether result = yyok, each state has been left with consistent
 *  data so that yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn,
                 yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      YYCHK (yyresolveStates (yys->yypred, yyn-1, yystackp, parser, scanner));
      if (! yys->yyresolved)
        YYCHK (yyresolveValue (yys, yystackp, parser, scanner));
    }
  return yyok;
}

/** Resolve the states for the RHS of YYOPT on *YYSTACKP, perform its
 *  user action, and return the semantic value and location in *YYVALP
 *  and *YYLOCP.  Regardless of whether result = yyok, all RHS states
 *  have been destroyed (assuming the user action destroys all RHS
 *  semantic values if invoked).  */
static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystackp,
                 YYSTYPE* yyvalp, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs = yyrhsLength (yyopt->yyrule);
  YYRESULTTAG yyflag =
    yyresolveStates (yyopt->yystate, yynrhs, yystackp, parser, scanner);
  if (yyflag != yyok)
    {
      yyGLRState *yys;
      for (yys = yyopt->yystate; yynrhs > 0; yys = yys->yypred, yynrhs -= 1)
        yydestroyGLRState ("Cleanup: popping", yys, parser, scanner);
      return yyflag;
    }

  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  if (yynrhs == 0)
    /* Set default location.  */
    yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yyopt->yystate->yyloc;
  {
    int yychar_current = yychar;
    YYSTYPE yylval_current = yylval;
    YYLTYPE yylloc_current = yylloc;
    yychar = yyopt->yyrawchar;
    yylval = yyopt->yyval;
    yylloc = yyopt->yyloc;
    yyflag = yyuserAction (yyopt->yyrule, yynrhs,
                           yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp, parser, scanner);
    yychar = yychar_current;
    yylval = yylval_current;
    yylloc = yylloc_current;
  }
  return yyflag;
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[1 + YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == YY_NULLPTR)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1, (unsigned long int) (yys->yyposn + 1),
               (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
        {
          if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
            YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]));
          else
            YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]),
                       (unsigned long int) (yystates[yyi-1]->yyposn + 1),
                       (unsigned long int) yystates[yyi]->yyposn);
        }
      else
        yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static YYRESULTTAG
yyreportAmbiguity (yySemanticOption* yyx0,
                   yySemanticOption* yyx1, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  YYUSE (yyx0);
  YYUSE (yyx1);

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif

  yyerror (yylocp, parser, scanner, YY_("syntax is ambiguous"));
  return yyabort;
}

/** Resolve the locations for each of the YYN1 states in *YYSTACKP,
 *  ending at YYS1.  Has no effect on previously resolved states.
 *  The first semantic option of a state is always chosen.  */
static void
yyresolveLocations (yyGLRState* yys1, int yyn1,
                    yyGLRStack *yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  if (0 < yyn1)
    {
      yyresolveLocations (yys1->yypred, yyn1 - 1, yystackp, parser, scanner);
      if (!yys1->yyresolved)
        {
          yyGLRStackItem yyrhsloc[1 + YYMAXRHS];
          int yynrhs;
          yySemanticOption *yyoption = yys1->yysemantics.yyfirstVal;
          YYASSERT (yyoption != YY_NULLPTR);
          yynrhs = yyrhsLength (yyoption->yyrule);
          if (yynrhs > 0)
            {
              yyGLRState *yys;
              int yyn;
              yyresolveLocations (yyoption->yystate, yynrhs,
                                  yystackp, parser, scanner);
              for (yys = yyoption->yystate, yyn = yynrhs;
                   yyn > 0;
                   yys = yys->yypred, yyn -= 1)
                yyrhsloc[yyn].yystate.yyloc = yys->yyloc;
            }
          else
            {
              /* Both yyresolveAction and yyresolveLocations traverse the GSS
                 in reverse rightmost order.  It is only necessary to invoke
                 yyresolveLocations on a subforest for which yyresolveAction
                 would have been invoked next had an ambiguity not been
                 detected.  Thus the location of the previous state (but not
                 necessarily the previous state itself) is guaranteed to be
                 resolved already.  */
              yyGLRState *yyprevious = yyoption->yystate;
              yyrhsloc[0].yystate.yyloc = yyprevious->yyloc;
            }
          {
            int yychar_current = yychar;
            YYSTYPE yylval_current = yylval;
            YYLTYPE yylloc_current = yylloc;
            yychar = yyoption->yyrawchar;
            yylval = yyoption->yyval;
            yylloc = yyoption->yyloc;
            YYLLOC_DEFAULT ((yys1->yyloc), yyrhsloc, yynrhs);
            yychar = yychar_current;
            yylval = yylval_current;
            yylloc = yylloc_current;
          }
        }
    }
}

/** Resolve the ambiguity represented in state YYS in *YYSTACKP,
 *  perform the indicated actions, and set the semantic value of YYS.
 *  If result != yyok, the chain of semantic options in YYS has been
 *  cleared instead or it has been left unmodified except that
 *  redundant options may have been removed.  Regardless of whether
 *  result = yyok, YYS has been left with consistent data so that
 *  yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveValue (yyGLRState* yys, yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  yySemanticOption* yyoptionList = yys->yysemantics.yyfirstVal;
  yySemanticOption* yybest = yyoptionList;
  yySemanticOption** yypp;
  yybool yymerge = yyfalse;
  YYSTYPE yysval;
  YYRESULTTAG yyflag;
  YYLTYPE *yylocp = &yys->yyloc;

  for (yypp = &yyoptionList->yynext; *yypp != YY_NULLPTR; )
    {
      yySemanticOption* yyp = *yypp;

      if (yyidenticalOptions (yybest, yyp))
        {
          yymergeOptionSets (yybest, yyp);
          *yypp = yyp->yynext;
        }
      else
        {
          switch (yypreference (yybest, yyp))
            {
            case 0:
              yyresolveLocations (yys, 1, yystackp, parser, scanner);
              return yyreportAmbiguity (yybest, yyp, yylocp, parser, scanner);
              break;
            case 1:
              yymerge = yytrue;
              break;
            case 2:
              break;
            case 3:
              yybest = yyp;
              yymerge = yyfalse;
              break;
            default:
              /* This cannot happen so it is not worth a YYASSERT (yyfalse),
                 but some compilers complain if the default case is
                 omitted.  */
              break;
            }
          yypp = &yyp->yynext;
        }
    }

  if (yymerge)
    {
      yySemanticOption* yyp;
      int yyprec = yydprec[yybest->yyrule];
      yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp, parser, scanner);
      if (yyflag == yyok)
        for (yyp = yybest->yynext; yyp != YY_NULLPTR; yyp = yyp->yynext)
          {
            if (yyprec == yydprec[yyp->yyrule])
              {
                YYSTYPE yysval_other;
                YYLTYPE yydummy;
                yyflag = yyresolveAction (yyp, yystackp, &yysval_other, &yydummy, parser, scanner);
                if (yyflag != yyok)
                  {
                    yydestruct ("Cleanup: discarding incompletely merged value for",
                                yystos[yys->yylrState],
                                &yysval, yylocp, parser, scanner);
                    break;
                  }
                yyuserMerge (yymerger[yyp->yyrule], &yysval, &yysval_other);
              }
          }
    }
  else
    yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp, parser, scanner);

  if (yyflag == yyok)
    {
      yys->yyresolved = yytrue;
      yys->yysemantics.yysval = yysval;
    }
  else
    yys->yysemantics.yyfirstVal = YY_NULLPTR;
  return yyflag;
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  if (yystackp->yysplitPoint != YY_NULLPTR)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystackp->yytops.yystates[0];
           yys != yystackp->yysplitPoint;
           yys = yys->yypred, yyn += 1)
        continue;
      YYCHK (yyresolveStates (yystackp->yytops.yystates[0], yyn, yystackp
                             , parser, scanner));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystackp)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystackp->yytops.yysize != 1 || yystackp->yysplitPoint == YY_NULLPTR)
    return;

  for (yyp = yystackp->yytops.yystates[0], yyq = yyp->yypred, yyr = YY_NULLPTR;
       yyp != yystackp->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystackp->yyspaceLeft += yystackp->yynextFree - yystackp->yyitems;
  yystackp->yynextFree = ((yyGLRStackItem*) yystackp->yysplitPoint) + 1;
  yystackp->yyspaceLeft -= yystackp->yynextFree - yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;

  while (yyr != YY_NULLPTR)
    {
      yystackp->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystackp->yynextFree->yystate.yypred = &yystackp->yynextFree[-1].yystate;
      yystackp->yytops.yystates[0] = &yystackp->yynextFree->yystate;
      yystackp->yynextFree += 1;
      yystackp->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystackp, size_t yyk,
                   size_t yyposn, YYLTYPE *yylocp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  while (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    {
      yyStateNum yystate = yystackp->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %lu Entering state %d\n",
                  (unsigned long int) yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
        {
          YYRESULTTAG yyflag;
          yyRuleNum yyrule = yydefaultAction (yystate);
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          yyflag = yyglrReduce (yystackp, yyk, yyrule, yyimmediate[yyrule], parser, scanner);
          if (yyflag == yyerr)
            {
              YYDPRINTF ((stderr,
                          "Stack %lu dies "
                          "(predicate failure or explicit user error).\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          if (yyflag != yyok)
            return yyflag;
        }
      else
        {
          yySymbol yytoken;
          int yyaction;
          const short int* yyconflicts;

          yystackp->yytops.yylookaheadNeeds[yyk] = yytrue;
          if (yychar == YYEMPTY)
            {
              YYDPRINTF ((stderr, "Reading a token: "));
              yychar = yylex (&yylval, &yylloc, scanner);
            }

          if (yychar <= YYEOF)
            {
              yychar = yytoken = YYEOF;
              YYDPRINTF ((stderr, "Now at end of input.\n"));
            }
          else
            {
              yytoken = YYTRANSLATE (yychar);
              YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
            }

          yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);

          while (*yyconflicts != 0)
            {
              YYRESULTTAG yyflag;
              size_t yynewStack = yysplitStack (yystackp, yyk);
              YYDPRINTF ((stderr, "Splitting off stack %lu from %lu.\n",
                          (unsigned long int) yynewStack,
                          (unsigned long int) yyk));
              yyflag = yyglrReduce (yystackp, yynewStack,
                                    *yyconflicts,
                                    yyimmediate[*yyconflicts], parser, scanner);
              if (yyflag == yyok)
                YYCHK (yyprocessOneStack (yystackp, yynewStack,
                                          yyposn, yylocp, parser, scanner));
              else if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr, "Stack %lu dies.\n",
                              (unsigned long int) yynewStack));
                  yymarkStackDeleted (yystackp, yynewStack);
                }
              else
                return yyflag;
              yyconflicts += 1;
            }

          if (yyisShiftAction (yyaction))
            break;
          else if (yyisErrorAction (yyaction))
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              break;
            }
          else
            {
              YYRESULTTAG yyflag = yyglrReduce (yystackp, yyk, -yyaction,
                                                yyimmediate[-yyaction], parser, scanner);
              if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr,
                              "Stack %lu dies "
                              "(predicate failure or explicit user error).\n",
                              (unsigned long int) yyk));
                  yymarkStackDeleted (yystackp, yyk);
                  break;
                }
              else if (yyflag != yyok)
                return yyflag;
            }
        }
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  if (yystackp->yyerrState != 0)
    return;
#if ! YYERROR_VERBOSE
  yyerror (&yylloc, parser, scanner, YY_("syntax error"));
#else
  {
  yySymbol yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);
  size_t yysize0 = yytnamerr (YY_NULLPTR, yytokenName (yytoken));
  size_t yysize = yysize0;
  yybool yysize_overflow = yyfalse;
  char* yymsg = YY_NULLPTR;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected").  */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[yystackp->yytops.yystates[0]->yylrState];
      yyarg[yycount++] = yytokenName (yytoken);
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for this
             state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;
          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytokenName (yyx);
                {
                  size_t yysz = yysize + yytnamerr (YY_NULLPTR, yytokenName (yyx));
                  yysize_overflow |= yysz < yysize;
                  yysize = yysz;
                }
              }
        }
    }

  switch (yycount)
    {
#define YYCASE_(N, S)                   \
      case N:                           \
        yyformat = S;                   \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  {
    size_t yysz = yysize + strlen (yyformat);
    yysize_overflow |= yysz < yysize;
    yysize = yysz;
  }

  if (!yysize_overflow)
    yymsg = (char *) YYMALLOC (yysize);

  if (yymsg)
    {
      char *yyp = yymsg;
      int yyi = 0;
      while ((*yyp = *yyformat))
        {
          if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
            {
              yyp += yytnamerr (yyp, yyarg[yyi++]);
              yyformat += 2;
            }
          else
            {
              yyp++;
              yyformat++;
            }
        }
      yyerror (&yylloc, parser, scanner, yymsg);
      YYFREE (yymsg);
    }
  else
    {
      yyerror (&yylloc, parser, scanner, YY_("syntax error"));
      yyMemoryExhausted (yystackp);
    }
  }
#endif /* YYERROR_VERBOSE */
  yynerrs += 1;
}

/* Recover from a syntax error on *YYSTACKP, assuming that *YYSTACKP->YYTOKENP,
   yylval, and yylloc are the syntactic category, semantic value, and location
   of the lookahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystackp, KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  size_t yyk;
  int yyj;

  if (yystackp->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
        yySymbol yytoken;
        if (yychar == YYEOF)
          yyFail (yystackp, &yylloc, parser, scanner, YY_NULLPTR);
        if (yychar != YYEMPTY)
          {
            /* We throw away the lookahead, but the error range
               of the shifted error token must take it into account.  */
            yyGLRState *yys = yystackp->yytops.yystates[0];
            yyGLRStackItem yyerror_range[3];
            yyerror_range[1].yystate.yyloc = yys->yyloc;
            yyerror_range[2].yystate.yyloc = yylloc;
            YYLLOC_DEFAULT ((yys->yyloc), yyerror_range, 2);
            yytoken = YYTRANSLATE (yychar);
            yydestruct ("Error: discarding",
                        yytoken, &yylval, &yylloc, parser, scanner);
          }
        YYDPRINTF ((stderr, "Reading a token: "));
        yychar = yylex (&yylval, &yylloc, scanner);
        if (yychar <= YYEOF)
          {
            yychar = yytoken = YYEOF;
            YYDPRINTF ((stderr, "Now at end of input.\n"));
          }
        else
          {
            yytoken = YYTRANSLATE (yychar);
            YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
          }
        yyj = yypact[yystackp->yytops.yystates[0]->yylrState];
        if (yypact_value_is_default (yyj))
          return;
        yyj += yytoken;
        if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != yytoken)
          {
            if (yydefact[yystackp->yytops.yystates[0]->yylrState] != 0)
              return;
          }
        else if (! yytable_value_is_error (yytable[yyj]))
          return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystackp->yytops.yysize; yyk += 1)
    if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
      break;
  if (yyk >= yystackp->yytops.yysize)
    yyFail (yystackp, &yylloc, parser, scanner, YY_NULLPTR);
  for (yyk += 1; yyk < yystackp->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystackp, yyk);
  yyremoveDeletes (yystackp);
  yycompressStack (yystackp);

  /* Now pop stack until we find a state that shifts the error token.  */
  yystackp->yyerrState = 3;
  while (yystackp->yytops.yystates[0] != YY_NULLPTR)
    {
      yyGLRState *yys = yystackp->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yypact_value_is_default (yyj))
        {
          yyj += YYTERROR;
          if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
              && yyisShiftAction (yytable[yyj]))
            {
              /* Shift the error token.  */
              /* First adjust its location.*/
              YYLTYPE yyerrloc;
              yystackp->yyerror_range[2].yystate.yyloc = yylloc;
              YYLLOC_DEFAULT (yyerrloc, (yystackp->yyerror_range), 2);
              YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
                               &yylval, &yyerrloc);
              yyglrShift (yystackp, 0, yytable[yyj],
                          yys->yyposn, &yylval, &yyerrloc);
              yys = yystackp->yytops.yystates[0];
              break;
            }
        }
      yystackp->yyerror_range[1].yystate.yyloc = yys->yyloc;
      if (yys->yypred != YY_NULLPTR)
        yydestroyGLRState ("Error: popping", yys, parser, scanner);
      yystackp->yytops.yystates[0] = yys->yypred;
      yystackp->yynextFree -= 1;
      yystackp->yyspaceLeft += 1;
    }
  if (yystackp->yytops.yystates[0] == YY_NULLPTR)
    yyFail (yystackp, &yylloc, parser, scanner, YY_NULLPTR);
}

#define YYCHK1(YYE)                                                          \
  do {                                                                       \
    switch (YYE) {                                                           \
    case yyok:                                                               \
      break;                                                                 \
    case yyabort:                                                            \
      goto yyabortlab;                                                       \
    case yyaccept:                                                           \
      goto yyacceptlab;                                                      \
    case yyerr:                                                              \
      goto yyuser_error;                                                     \
    default:                                                                 \
      goto yybuglab;                                                         \
    }                                                                        \
  } while (0)

/*----------.
| yyparse.  |
`----------*/

int
yyparse (KOpeningHours::OpeningHoursPrivate *parser, yyscan_t scanner)
{
  int yyresult;
  yyGLRStack yystack;
  yyGLRStack* const yystackp = &yystack;
  size_t yyposn;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY;
  yylval = yyval_default;
  yylloc = yyloc_default;

  if (! yyinitGLRStack (yystackp, YYINITDEPTH))
    goto yyexhaustedlab;
  switch (YYSETJMP (yystack.yyexception_buffer))
    {
    case 0: break;
    case 1: goto yyabortlab;
    case 2: goto yyexhaustedlab;
    default: goto yybuglab;
    }
  yyglrShift (&yystack, 0, 0, 0, &yylval, &yylloc);
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
         specialized to deterministic operation (single stack, no
         potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
        {
          yyRuleNum yyrule;
          int yyaction;
          const short int* yyconflicts;

          yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
          if (yystate == YYFINAL)
            goto yyacceptlab;
          if (yyisDefaultedState (yystate))
            {
              yyrule = yydefaultAction (yystate);
              if (yyrule == 0)
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack, parser, scanner);
                  goto yyuser_error;
                }
              YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue, parser, scanner));
            }
          else
            {
              yySymbol yytoken;
              if (yychar == YYEMPTY)
                {
                  YYDPRINTF ((stderr, "Reading a token: "));
                  yychar = yylex (&yylval, &yylloc, scanner);
                }

              if (yychar <= YYEOF)
                {
                  yychar = yytoken = YYEOF;
                  YYDPRINTF ((stderr, "Now at end of input.\n"));
                }
              else
                {
                  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
                }

              yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
              if (*yyconflicts != 0)
                break;
              if (yyisShiftAction (yyaction))
                {
                  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
                  yychar = YYEMPTY;
                  yyposn += 1;
                  yyglrShift (&yystack, 0, yyaction, yyposn, &yylval, &yylloc);
                  if (0 < yystack.yyerrState)
                    yystack.yyerrState -= 1;
                }
              else if (yyisErrorAction (yyaction))
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack, parser, scanner);
                  goto yyuser_error;
                }
              else
                YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue, parser, scanner));
            }
        }

      while (yytrue)
        {
          yySymbol yytoken_to_shift;
          size_t yys;

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            yystackp->yytops.yylookaheadNeeds[yys] = yychar != YYEMPTY;

          /* yyprocessOneStack returns one of three things:

              - An error flag.  If the caller is yyprocessOneStack, it
                immediately returns as well.  When the caller is finally
                yyparse, it jumps to an error label via YYCHK1.

              - yyok, but yyprocessOneStack has invoked yymarkStackDeleted
                (&yystack, yys), which sets the top state of yys to NULL.  Thus,
                yyparse's following invocation of yyremoveDeletes will remove
                the stack.

              - yyok, when ready to shift a token.

             Except in the first case, yyparse will invoke yyremoveDeletes and
             then shift the next token onto all remaining stacks.  This
             synchronization of the shift (that is, after all preceding
             reductions on all stacks) helps prevent double destructor calls
             on yylval in the event of memory exhaustion.  */

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn, &yylloc, parser, scanner));
          yyremoveDeletes (&yystack);
          if (yystack.yytops.yysize == 0)
            {
              yyundeleteLastStack (&yystack);
              if (yystack.yytops.yysize == 0)
                yyFail (&yystack, &yylloc, parser, scanner, YY_("syntax error"));
              YYCHK1 (yyresolveStack (&yystack, parser, scanner));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
           yystack.yyerror_range[1].yystate.yyloc = yylloc;
              yyreportSyntaxError (&yystack, parser, scanner);
              goto yyuser_error;
            }

          /* If any yyglrShift call fails, it will fail after shifting.  Thus,
             a copy of yylval will already be on stack 0 in the event of a
             failure in the following loop.  Thus, yychar is set to YYEMPTY
             before the loop to make sure the user destructor for yylval isn't
             called twice.  */
          yytoken_to_shift = YYTRANSLATE (yychar);
          yychar = YYEMPTY;
          yyposn += 1;
          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            {
              int yyaction;
              const short int* yyconflicts;
              yyStateNum yystate = yystack.yytops.yystates[yys]->yylrState;
              yygetLRActions (yystate, yytoken_to_shift, &yyaction,
                              &yyconflicts);
              /* Note that yyconflicts were handled by yyprocessOneStack.  */
              YYDPRINTF ((stderr, "On stack %lu, ", (unsigned long int) yys));
              YY_SYMBOL_PRINT ("shifting", yytoken_to_shift, &yylval, &yylloc);
              yyglrShift (&yystack, yys, yyaction, yyposn,
                          &yylval, &yylloc);
              YYDPRINTF ((stderr, "Stack %lu now in state #%d\n",
                          (unsigned long int) yys,
                          yystack.yytops.yystates[yys]->yylrState));
            }

          if (yystack.yytops.yysize == 1)
            {
              YYCHK1 (yyresolveStack (&yystack, parser, scanner));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
              yycompressStack (&yystack);
              break;
            }
        }
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack, parser, scanner);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }

 yyacceptlab:
  yyresult = 0;
  goto yyreturn;

 yybuglab:
  YYASSERT (yyfalse);
  goto yyabortlab;

 yyabortlab:
  yyresult = 1;
  goto yyreturn;

 yyexhaustedlab:
  yyerror (&yylloc, parser, scanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;

 yyreturn:
  if (yychar != YYEMPTY)
    yydestruct ("Cleanup: discarding lookahead",
                YYTRANSLATE (yychar), &yylval, &yylloc, parser, scanner);

  /* If the stack is well-formed, pop the stack until it is empty,
     destroying its entries as we go.  But free the stack regardless
     of whether it is well-formed.  */
  if (yystack.yyitems)
    {
      yyGLRState** yystates = yystack.yytops.yystates;
      if (yystates)
        {
          size_t yysize = yystack.yytops.yysize;
          size_t yyk;
          for (yyk = 0; yyk < yysize; yyk += 1)
            if (yystates[yyk])
              {
                while (yystates[yyk])
                  {
                    yyGLRState *yys = yystates[yyk];
                 yystack.yyerror_range[1].yystate.yyloc = yys->yyloc;
                  if (yys->yypred != YY_NULLPTR)
                      yydestroyGLRState ("Cleanup: popping", yys, parser, scanner);
                    yystates[yyk] = yys->yypred;
                    yystack.yynextFree -= 1;
                    yystack.yyspaceLeft += 1;
                  }
                break;
              }
        }
      yyfreeGLRStack (&yystack);
    }

  return yyresult;
}

/* DEBUGGING ONLY */
#if YYDEBUG
static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      YYFPRINTF (stderr, " -> ");
    }
  YYFPRINTF (stderr, "%d@%lu", yys->yylrState,
             (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == YY_NULLPTR)
    YYFPRINTF (stderr, "<null>");
  else
    yy_yypstack (yyst);
  YYFPRINTF (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystackp, size_t yyk)
{
  yypstates (yystackp->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)                                                         \
    ((YYX) == YY_NULLPTR ? -1 : (yyGLRStackItem*) (YYX) - yystackp->yyitems)


static void
yypdumpstack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystackp->yyitems; yyp < yystackp->yynextFree; yyp += 1)
    {
      YYFPRINTF (stderr, "%3lu. ",
                 (unsigned long int) (yyp - yystackp->yyitems));
      if (*(yybool *) yyp)
        {
          YYASSERT (yyp->yystate.yyisState);
          YYASSERT (yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
                     yyp->yystate.yyresolved, yyp->yystate.yylrState,
                     (unsigned long int) yyp->yystate.yyposn,
                     (long int) YYINDEX (yyp->yystate.yypred));
          if (! yyp->yystate.yyresolved)
            YYFPRINTF (stderr, ", firstVal: %ld",
                       (long int) YYINDEX (yyp->yystate
                                             .yysemantics.yyfirstVal));
        }
      else
        {
          YYASSERT (!yyp->yystate.yyisState);
          YYASSERT (!yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Option. rule: %d, state: %ld, next: %ld",
                     yyp->yyoption.yyrule - 1,
                     (long int) YYINDEX (yyp->yyoption.yystate),
                     (long int) YYINDEX (yyp->yyoption.yynext));
        }
      YYFPRINTF (stderr, "\n");
    }
  YYFPRINTF (stderr, "Tops:");
  for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
    YYFPRINTF (stderr, "%lu: %ld; ", (unsigned long int) yyi,
               (long int) YYINDEX (yystackp->yytops.yystates[yyi]));
  YYFPRINTF (stderr, "\n");
}
#endif

#undef yylval
#undef yychar
#undef yynerrs
#undef yylloc



#line 890 "openinghoursparser.y" /* glr.c:2584  */

